<?php
class MaroyakaWebClapWidget extends WP_Widget {
	function __construct() {
		parent::WP_Widget(
			'MaroyakaWebClapWidget' ,
			'WEB拍手ランキング' ,
			array(
				'classname' => 'maroyaka-webclap-ranking-widget', 
				'description' => 'まろやかWEB拍手 for WordPressの拍手ページをランキング形式で表示します'
				)
			);	
	}

	function form($instance) {
		$default = array(
			'title' => 'WEB拍手ランキング',
			'maxview' => 10,
			'coloring' => 'default',
			'period' => 1,
			'view_id' => 0,
			'view_eyecatch' => 0,
		);
		$instance = wp_parse_args((array) $instance, $default);
		?>
		<div class="mwc-widget">
			<p>
				<label for="<?php echo $this->get_field_id('title'); ?>">タイトル：</label>
				<input type="text" class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" value="<?php echo $instance['title']; ?>" >
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('maxview'); ?>">最大表示順位：</label>
				<input type="text" size="3" id="<?php echo $this->get_field_id('maxview'); ?>" name="<?php echo $this->get_field_name('maxview'); ?>" value="<?php echo $instance['maxview']; ?>" >
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('period'); ?>">
				<input type="checkbox" id="<?php echo $this->get_field_id('period'); ?>"  name="<?php echo $this->get_field_name('period'); ?>" value="1" <?php checked($instance['period'], 1); ?>> 期間を選択可能にする</label>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('view_id'); ?>">
				<input type="checkbox" id="<?php echo $this->get_field_id('view_id'); ?>"  name="<?php echo $this->get_field_name('view_id'); ?>" value="1" <?php checked($instance['view_id'], 1); ?>> 記事IDを表示する</label>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('view_eyecatch'); ?>">
				<input type="checkbox" id="<?php echo $this->get_field_id('view_eyecatch'); ?>"  name="<?php echo $this->get_field_name('view_eyecatch'); ?>" value="1" <?php checked($instance['view_eyecatch'], 1); ?>> アイキャッチを表示する</label>
			</p>
			<?php
			$f_radio_id= $this->get_field_id('coloring');
			$f_radio_name = $this->get_field_name('coloring');
			$data = array(
				'default',
				'primary',
				'success',
				'info',
				'warning',
				'danger',
			);
			?>
			<p>
				<label for="<?php echo $f_radio_id; ?>">カラーリング：</label><br />
				<?php foreach ($data as $k => $v) :
					$lk = $f_radio_id. '_'. $k;
					?>
					<label for ="<?php echo $lk; ?>">
						<input type="radio" name="<?php echo $f_radio_name; ?>" id="<?php echo $lk; ?>" value="<?php echo $v; ?>" <?php checked($instance['coloring'], $v); ?>><span class="text-<?php echo $v; ?>">■</span>
					</label>&nbsp;
					<?php  ?>
				<?php endforeach; ?>
			</p>
		</div>
		<?php
	}

	function update($new_instance, $old_instance) {
		$instance = $old_instance;
		$instance['title'] = esc_attr($new_instance['title']);
		$instance['maxview'] = is_numeric($new_instance['maxview']) ? $new_instance['maxview'] : 10;
		$instance['coloring'] = esc_attr($new_instance['coloring']);
		$instance['period'] = ($new_instance['period'] == 1) ? 1 : '';
		$instance['view_eyecatch'] = ($new_instance['view_eyecatch'] == 1) ? 1 : '';
		$instance['view_id'] = ($new_instance['view_id'] == 1) ? 1 : '';
		return $instance;
	}

	function widget($args, $instance) {
		extract($args);

		echo $before_widget;

		if (!empty($instance['title'])) : ?>
			<?php echo $before_title. $instance['title']. $after_title; ?>
		<?php endif; ?>
		<?php if (!empty($instance['period'])) : ?>
			<div class="mwc-ranking-navi" data-widget-id="<?php echo $args['widget_id']; ?>" data-maxview="<?php echo $instance['maxview'] ?>">
				<div class="item active" data-toggle="mwc-ranking" data-mode="">総合</div
				>|<div class="item" data-toggle="mwc-ranking" data-mode="month"><a href="#">一ヶ月</a></div
				>|<div class="item" data-toggle="mwc-ranking" data-mode="week"><a href="#">一週</a></div
				>|<div class="item" data-toggle="mwc-ranking" data-mode="yesterday"><a href="#">昨日</a></div
				>|<div class="item" data-toggle="mwc-ranking" data-mode="today"><a href="#">今日</a></div>
			</div>
		<?php endif; ?>
		<div class="mwc-ranking-table color-<?php echo $instance['coloring']; ?>">
			<div class="thead">
				<div class="tr">
					<div class="td column-rank">順位</div>
					<div class="td column-count">拍手数</div>
					<div class="td column-label">ページ</div>
				</div>
			</div>
			<div class="tbody">
				<script type="text/javascript">
				jQuery(document).ready(function($) {
					$.ajax({
						url: _mwc.ajax_url,
						type: 'POST',
						dataType: 'json',
						timeout: 10000,
						cache : false,
						data: {
							'action': 'ranking',
							'widgetID': '<?php echo $args['widget_id']; ?>',
							'maxview': '<?php echo $instance['maxview'] ?>',
							'mode': ''
						}
					}).
					fail(function(xhr, status, error) {
						var res = xhr.status + ' ' + xhr.statusText;
						alert(res);
					}).
					done(function(data) {
						if (data.error) {
							alert('処理が中断されました。');
							return;
						}

						$('[data-widget-id="<?php echo $args['widget_id']; ?>"]').
							next('.mwc-ranking-table').children('.tbody').html(data);
					});
				});
				</script>
			</div>
		</div>
		<?php

		echo $after_widget;
	}
}
add_action('widgets_init', create_function('', 'return register_widget("MaroyakaWebClapWidget");'));
