<?php
new MaroyakaWebClapButton();

class MaroyakaWebClapButton extends MaroyakaWebClap {

	function __construct() {
		parent::__construct();
		add_action('wp_enqueue_scripts', array($this, 'add_scripts'));
		add_shortcode('maroyaka_webclap', array($this, 'shortcode'));
		add_filter('the_content', array($this, 'output_content'), MWC_PRIORITY_NUM);
		add_filter('the_excerpt', array($this, 'output_content'), MWC_PRIORITY_NUM);
	}

	///////////////////////////////////////
	/* CSS&JavaScript登録 */
	///////////////////////////////////////
	public function add_scripts() {
		wp_enqueue_style('mwc_style', MWC_PLUGIN_URL. '/css/mwc.css');
		wp_enqueue_script('jquery');
		wp_enqueue_script('mwc_script', MWC_PLUGIN_URL. '/js/mwc.js', array(), $this->version, true);
		wp_localize_script(
			'mwc_script',
			'_mwc',
			array(
				'ajax_url' => admin_url('admin-ajax.php'),
				'ajax_nonce' => wp_create_nonce('mwc_claping'),
				'loading_img_url' => MWC_PLUGIN_URL. '/img/loading.gif',
			)
		);
	}

	///////////////////////////////////////
	/* 拍手ボタン生成 */
	///////////////////////////////////////
	public function clap_button($post_id = null, $text = null, $btn_color = null) {
		if (is_null($post_id)) $post_id = esc_attr(get_the_ID());
		if (is_null($text)) $text = 'WEB拍手';
		if (is_null($btn_color)) $btn_color = $this->get_option('btn_color', 'default');

		$before = '';
		if ($this->get_option('btn_count_view') == 1) {
			$clap_obj = $this->db->get_row($this->db->prepare("SELECT * FROM ". $this->prefix. MWC_DB_TABLE_ID. " WHERE post_id = %s", $post_id));
			$count = (is_null($clap_obj)) ? 0 : $clap_obj->count;

			if ($this->get_option('btn_type') == 'normal') {
				$text .= ' <span class="count">'. $count. '</span>';
			} else {
				$before = '<span class="balloon"><span class="inner"><span class="count">'. $count. '</span></span></span>';
			}
		}

		$button = '<div class="maroyaka-webclap mwc-claping" style="text-align: '. $this->get_option('btn_align'). ';">'.
									'<button class="btn btn-'. $btn_color. ' btn-xs" data-id="'. $post_id. '">'. $text. '</button>'. $before.
								'</div>';
		return $button;
	}

	///////////////////////////////////////
	/* ショートコード */
	///////////////////////////////////////
	public function shortcode($atts) {
		extract(shortcode_atts(array(
			'id' => get_the_ID(),
			'text' => 'WEB拍手',
			'btn_color' => 'default',
		), $atts));

		return $this->clap_button($id, $text, $btn_color);
	}

	///////////////////////////////////////
	/* 記事に出力 */
	///////////////////////////////////////
	public function output_content($text) {
		$deny_btn = get_post_meta(get_the_ID(), 'mwc_deny_btn', true);
		if (empty($deny_btn)) {
			if (
				($this->get_option('btn_locate_single') == 1 && is_single())
				or
				($this->get_option('btn_locate_page') == 1 && is_page())
				or
				($this->get_option('btn_locate_loop') == 1 && in_the_loop() && !is_page())
				) {
				$btn_text = $this->get_option('btn_text');
				$text .= $this->clap_button(null, $btn_text);
			}
		}
		return $text;
	}
}
